#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from decimal import Decimal
from sigpdv.control.utils import exec_sql


class CadPromoCapa(object):
    def __init__(self, parent):
        self.parent = parent

    @Log
    def calcula_descontos_promo(self, dinheiro=False):
        if self.parent._coupon_totalize: # cupom ja totalizado, nao precisa calcular o desconto
            return 'Cupom totalizado'

        # caso tenha calculado alguma promocao de dinheiro que possa ter bloqueado a pesquisa de
        # socio tocedor, ao trocar de tela de pagamento indica que o socio nao foi calculado
        if not dinheiro:
            for i in self.parent.list_itens_desconto_promo:
                if i.get('somente_dinheiro'):
                    self.parent.desconto_socio_calculado = False
                    break

        self.parent.desconto_promo = Decimal(0)
        self.parent.list_itens_desconto_promo = []
        self.parent.obj_cad_promo1.calcula_promocao1()
        self.parent.obj_cad_promo2.calcula_promocao2()
        self.parent.obj_cad_promo3p.calcula_promocao3()
        self.parent.obj_cad_promo4.calcula_promocao4()
        self.parent.obj_cad_promo5p.calcula_promocao5()
        self.parent.obj_cad_promo6.calcula_promocao6()
        self.parent.obj_cad_promo7.calcula_promocao7()
        # promo 8 nao estra nesta lista
        promo_ids = map(lambda x: str(int(x.get('id_promo'))), self.parent.list_itens_desconto_promo)
        promos = []
        promos.extend(self.parent.list_itens_desconto_promo)
        self.parent.list_itens_desconto_promo = []
        if self.parent.cliente.supcli_cnpj_cpf:  # calcula apenas quando cliente eh informado
            self.parent.obj_cad_promo8.calcula_promocao8()
        promos8 = []
        promos8.extend(self.parent.list_itens_desconto_promo)
        self.parent.list_itens_desconto_promo = promos
        self.parent.list_itens_desconto_promo.extend(promos8)
        sequencia_promo_8 = {}
        dict_promo = {}
        for i in promos8:
            sequencia_promo_8.update({i.get('sequencia_item'): i.get('id_promo')})

        analisa_desconto = {}
        for i in self.parent.list_itens_desconto_promo:
            id_promo = i.get('id_promo')
            if not dict_promo.get(id_promo):
                dict_promo[id_promo] = {'sequencia_item': [i.get('sequencia_item')],
                                        'desconto': i.get('desconto') or 0,
                                        'promo_8': i.get('promo_8') or False}
            else:
                dict_promo[id_promo]['sequencia_item'].append(i.get('sequencia_item'))
                dict_promo[id_promo]['desconto'] += i.get('desconto') or 0
            if not i.get('promo_8') and sequencia_promo_8.get(i.get('sequencia_item')):
                analisa_desconto.update({id_promo: sequencia_promo_8.get(i.get('sequencia_item'))})

        total_desconto = 0
        aux = []
        dict_lista = {}
        if promo_ids:
            for i in exec_sql("""SELECT * 
                                 FROM caixa_cad_lista_clientes 
                                 WHERE supclc_id_promo in (%s)""" % ','.join(promo_ids)):
                promo_id = ('%s' % i.get('supclc_id_promo')).zfill(6)
                cliente = (i.get('supclc_cnpj_cpf')).zfill(15)
                if promo_id not in dict_lista:
                    dict_lista[promo_id] = [cliente]
                else:
                    dict_lista[promo_id].append(cliente)

        promo8_ids = map(lambda x: str(int(x.get('id_promo'))), promos8)
        dict_lista_8 = {}
        if promo8_ids:
            for i in exec_sql("""SELECT * 
                                 FROM caixa_cad_lista_clientes 
                                 WHERE supclc_id_promo in (%s)""" % ','.join(promo8_ids)):
                promo_id = ('%s' % i.get('supclc_id_promo')).zfill(6)
                cliente = (i.get('supclc_cnpj_cpf')).zfill(15)
                if promo_id not in dict_lista_8:
                    dict_lista_8[promo_id] = [cliente]
                else:
                    dict_lista_8[promo_id].append(cliente)

        retira_promo = []
        retira_item_promo_8 = []
        for i in self.parent.list_itens_desconto_promo:
            # retira as promocoes que sao em dinheiro mas o pagamento nao foi feito com o mesmo
            if i.get('somente_dinheiro') and not dinheiro:
                continue

            id_promo = i.get('id_promo')
            lista_clientes = dict_lista.get(id_promo) or []
            lista_clientes_8 = dict_lista_8.get(id_promo) or []
            # as promocoes que sao especificas de clientes na lista mas o cliente do cupom nao
            # esta na lista, Obs tipo_promo = 2 sig, ignora as Scanntech
            if i.get('tipo_promo') == '2' and lista_clientes and \
                    self.parent.cliente.supcli_cnpj_cpf not in lista_clientes:
                continue

            if i.get('promo_8'):
                # se o cliente nao esta na promo 8, ja tira o desconto
                if self.parent.cliente.supcli_cnpj_cpf not in lista_clientes_8:
                    continue
                if i.get('sequencia_item') in retira_item_promo_8:
                    continue

            else:
                if id_promo in retira_promo:
                    continue

                if analisa_desconto.get(id_promo):
                    key = analisa_desconto.get(id_promo)
                    # compara os descontos apenas se o cliente estiver na lista da promocao 8
                    if dict_lista_8.get(key) and self.parent.cliente.supcli_cnpj_cpf in dict_lista_8.get(key):
                        desc = dict_promo.get(id_promo).get('desconto')
                        desc_8 = dict_promo.get(key).get('desconto')
                        if desc >= desc_8:
                            retira_item_promo_8.extend(dict_promo.get(key).get('sequencia_item'))
                            analisa_desconto.pop(id_promo)
                        else:
                            # retira todos itens desta promocao
                            retira_promo.append(id_promo)
                            continue

            #Todo: ao trocar a ordem das promocoes verificar como proceder nesta parte
            if self.parent.dict_mov_corpos_socio and \
                              self.parent.dict_mov_corpos_socio.get('%s' % i.get('sequencia_item')):
                self.parent.desconto_socio_torcedor -= self.parent.dict_mov_corpos_socio.get(
                                                    '%s' % i.get('sequencia_item')).get('desconto')
                del self.parent.dict_mov_corpos_socio['%s' % i.get('sequencia_item')]

            total_desconto += i.get('desconto')
            aux.append(i)

        self.parent.list_itens_desconto_promo = aux
        if total_desconto > 0:
            self.parent.desconto_promo = total_desconto

        self.parent.atualiza_valor_a_pagar()
        Ecfk_ScnPlusOk = True

        return self.parent.list_itens_desconto_promo or 'Sem promocao'